var modifyFieldName = 'location';
var searchUrlReg = /https:\/\/www\.baidu\.com\/link\?url=/;

chrome.webRequest.onBeforeSendHeaders.addListener(function(details){
    var url = details.url;
    if (searchUrlReg.test(url)) {
      details.requestHeaders.push({
        name: 'Access-Control-Expose-Headers',
        value: 'Redirect'
      });
    }
    return {requestHeaders: details.requestHeaders};
},
{
  urls : ["<all_urls>"]
},
["blocking", "requestHeaders"]);

chrome.webRequest.onHeadersReceived.addListener(function(details) {
  var url = details.url;
  var responseHeaders = details.responseHeaders;
  var allowOriginHeader = responseHeaders.find(function(rh, index){
    if (rh.name === modifyFieldName) {
      responseHeaders[index]['value'] = 'https://www.baidu.com/';
      return true;
    }
    if (rh.name.toLowerCase() === modifyFieldName.toLowerCase() && searchUrlReg.test(url)) {
      responseHeaders.push({
        name: 'redirect',
        value: rh.value
      });
      responseHeaders.splice(index, 1);
    }
  });
  return {
    responseHeaders: responseHeaders
  };
},
{
  urls : ["<all_urls>"]
},
["responseHeaders","blocking"]);
