(function() {
  let timer = null;
  const container = document.querySelector('#center_col');

  replaceUrl();

  watchUpdate();

  function replaceUrl() {
    unWatchUpdate();
    const resultLink = [].slice.call(document.querySelectorAll('h3 a'), 0);
    resultLink.forEach(function(item) {
      var url = item.getAttribute('href');
      if (/url\?.*/.test(url)) {
        var matches = /url=([^&]*)/.exec(url);
        if (matches) {
          item.href = decodeURIComponent(matches[1]);
        }
      }
    });
    watchUpdate();
  }

  function watchUpdate() {
    container.addEventListener('DOMSubtreeModified', function() {
      handleUpdate();
    }, false);
  }

  function unWatchUpdate() {
    container.removeEventListener('DOMSubtreeModified', handleUpdate);
  }

  function handleUpdate() {
    timer && clearTimeout(timer);
    timer = setTimeout(function() {
      replaceUrl();
    });
  }
}());
